/*
 *  TOPPERS ATK2
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Kernel Version 2
 *
 *  Copyright (C) 2008-2013 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2011-2013 by FUJISOFT INCORPORATED, JAPAN
 *  Copyright (C) 2011-2013 by FUJITSU VLSI LIMITED, JAPAN
 *  Copyright (C) 2011-2013 by NEC Communication Systems, Ltd., JAPAN
 *  Copyright (C) 2011-2013 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
 *  Copyright (C) 2011-2013 by Renesas Electronics Corporation, JAPAN
 *  Copyright (C) 2011-2013 by Sunny Giken Inc., JAPAN
 *  Copyright (C) 2011-2013 by TOSHIBA CORPORATION, JAPAN
 *  Copyright (C) 2011-2013 by Witz Corporation, JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: prc_config.c 7286 2013-03-29 06:24:54Z fsi-dankei $
 */

/*
 *		ץå¸⥸塼Nios2ѡ
 */
#include "kernel_impl.h"
#include "prc_ici.h"

/*
 *  CPU㳰װݻѿ
 */
#ifdef CFG_USE_PROTECTIONHOOK
/* CPU㳰ȯCPU㳰װֹݻѿ */
uint32	nios2_cpu_exp_no[TotalNumberOfCores];

/* CPU㳰ȯץ५󥿡PC - 4ˤݻѿ */
uint32	nios2_cpu_exp_pc[TotalNumberOfCores];

/* CPU㳰ȯCPU㳰ȯսʥɥ쥹ˤݻѿ */
uint32	nios2_cpu_exp_bad_addr[TotalNumberOfCores];

/* CPU㳰ȯåݥ󥿤ݻѿ */
uint32	nios2_cpu_exp_sp[TotalNumberOfCores];
#endif /* CFG_USE_PROTECTIONHOOK */

void
prc_hardware_initialize(void)
{
	vic_initialize();
}

/*
 *  ץå¸ν
 */
void
prc_initialize(void)
{
	TCCB *p_tccb = &(get_my_p_ccb()->target_ccb);

	/*
	 *  ͥ뵯ư󥿥ƥȤȤư뤿1
	 */
	p_tccb->except_nest_cnt = 1U;

	p_tccb->trusted_hook_savedsp = 0U;

	p_tccb->nested_lock_os_int_cnt = 0U;
	p_tccb->saved_status_il = 0U;
}

/*
 *  ץå¸νλ
 */
void
prc_terminate(void)
{
	CoreIdType coreid;

	coreid = x_core_id();
	/*
	 *  ߤƤ뤫Ƚꤹ뤿Ѥ쥸򥯥ꥢ
	 */
	*((volatile uint32 *) (SYSVER_REG5 + (4 * coreid))) = 0;
}

/*
 *  ׵饤°
 */
void
x_config_int(InterruptNumberType intno, AttributeType intatr, PriorityType intpri)
{
	ASSERT(VALID_INTNO(intno));

	/* ͥꡤꤷʤͥ0Ȥʤ */
	vic_set_int_config((uint8) INTNO_MASK(intno), INT_IPM(intpri));

	/* SC1Ǥϵưϳߵ */
	vic_set_int_enable(INTNO_BITPAT(INTNO_MASK(intno)));
}

#ifndef OMIT_DEFAULT_INT_HANDLER

/*
 *  ̤γߤäν
 */
void
default_int_handler(void)
{
	target_fput_str("Unregistered Interrupt occurs.");
	ASSERT(0);
}

#endif /* OMIT_DEFAULT_INT_HANDLER */
