/*
 *  TOPPERS ATK2
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Kernel Version 2
 *
 *  Copyright (C) 2011-2013 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2011-2013 by FUJISOFT INCORPORATED, JAPAN
 *  Copyright (C) 2011-2013 by FUJITSU VLSI LIMITED, JAPAN
 *  Copyright (C) 2011-2013 by NEC Communication Systems, Ltd., JAPAN
 *  Copyright (C) 2011-2013 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
 *  Copyright (C) 2011-2013 by Renesas Electronics Corporation, JAPAN
 *  Copyright (C) 2011-2013 by Sunny Giken Inc., JAPAN
 *  Copyright (C) 2011-2013 by TOSHIBA CORPORATION, JAPAN
 *  Copyright (C) 2011-2013 by Witz Corporation, JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: Std_Types.h 7325 2013-04-05 06:23:17Z shigihara $
 */

/*
 *		AUTOSARͶ̵Υǡޥ
 *
 *  ΥإåեϡAUTOSARͶ̵Υǡޥ
 *  ޤإåե
 *  AUTOSARͤȤθߴɬפȤ륢ץꥱ󤬥󥯥롼
 *  뤳ȤꤷƤ
 *  ATK2Υѥɬפʶ̤ܥإåˤ
 *
 *  ֥Υե뤫餳Υե򥤥󥯥롼ɤ
 *  ϡTOPPERS_MACRO_ONLYƤ
 *  ˤꡤޥʳ褦ˤʤäƤ
 */

#ifndef TOPPERS_STD_TYPES_H
#define TOPPERS_STD_TYPES_H

#include "Platform_Types.h"
#include "Compiler.h"

/*
 *  ATK2
 */
#ifndef UINT_C
#define UINT_C(val)		(val ## U)      /* ̵ޥ */
#endif /* UINT_C */

/* ̵ݥ */
#ifndef NULL
#define NULL		((void *) 0)
#endif /* NULL */

/*
 *  ˴ؤФΥޥ
 */
#ifndef offsetof
#define offsetof(structure, field)	((uintptr) & (((structure *) 0)->field))
#endif /* offsetof */


/*
 *  AUTOSAR͵
 */

/*
 *  Type definitions
 */
#ifndef TOPPERS_MACRO_ONLY

typedef uint8 Std_ReturnType;

typedef struct {
	uint16	vendorID;
	uint16	moduleID;
	uint8	sw_major_version;
	uint8	sw_minor_version;
	uint8	sw_patch_version;
} Std_VersionInfoType;

#endif /* TOPPERS_MACRO_ONLY */

/*
 *  Symbol definitions
 */
#ifndef STATUSTYPEDEFINED
#define STATUSTYPEDEFINED

#ifndef TOPPERS_MACRO_ONLY
typedef unsigned char StatusType;   /* OSEK compliance */
#endif /* TOPPERS_MACRO_ONLY */

#define E_OK		UINT_C(0x00)
#endif /* STATUSTYPEDEFINED */

#define E_NOT_OK	UINT_C(0x01)

#define STD_HIGH	UINT_C(1)   /* Physical state 5V or 3.3V */
#define STD_LOW		UINT_C(0)   /* Physical state 0V         */

#define STD_ACTIVE	UINT_C(1)   /* Logical state active */
#define STD_IDLE	UINT_C(0)   /* Logical state idle   */

#define STD_ON		UINT_C(1)
#define STD_OFF		UINT_C(0)

#endif /* TOPPERS_STD_TYPES_H */
