/*
 *  TOPPERS ATK2
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Kernel Version 2
 *
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2004-2013 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2011-2013 by FUJISOFT INCORPORATED, JAPAN
 *  Copyright (C) 2011-2013 by FUJITSU VLSI LIMITED, JAPAN
 *  Copyright (C) 2011-2013 by NEC Communication Systems, Ltd., JAPAN
 *  Copyright (C) 2011-2013 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
 *  Copyright (C) 2011-2013 by Renesas Electronics Corporation, JAPAN
 *  Copyright (C) 2011-2013 by Sunny Giken Inc., JAPAN
 *  Copyright (C) 2011-2013 by TOSHIBA CORPORATION, JAPAN
 *  Copyright (C) 2011-2013 by Witz Corporation, JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: t_syslog.h 7643 2013-06-27 11:01:00Z fsi-dankei $
 */

/*
 *		ƥϤԤ
 *
 *  ƥӥϡƥΥϤ뤿Υӥ
 *  Ǥ
 *  ͥ뤫ΥνϤˤѤ뤿ᡤԤ֤ˤϤ
 *  ȤϤʤ
 *
 *  ϡͥΥХåե˽񤭹फ٥ʸ
 *  ϴؿѤƽϤ
 *  ɤȤϡĥӥڤ괹뤳ȤǤ
 *
 *  Хåեΰ褬ХեˤϡŤäƾ
 *  񤭤
 *
 *  ֥Υե뤫餳Υե򥤥󥯥롼ɤ
 *  ϡTOPPERS_MACRO_ONLYƤȤǡޥʳεҤ
 *  ȤǤ
 */

#ifndef TOPPERS_T_SYSLOG_H
#define TOPPERS_T_SYSLOG_H

#include "Os.h"

/*
 *  μ̤
 */
#define LOG_TYPE_COMMENT	UINT_C(0x01)    /*  */
#define LOG_TYPE_ASSERT		UINT_C(0x02)    /* μ */

#define LOG_TYPE_ISR			UINT_C(0x11)    /* ߥӥ롼 */
#define LOG_TYPE_ALM			UINT_C(0x12)    /* 顼ϥɥ */
#define LOG_TYPE_TSKSTAT		UINT_C(0x13)    /* Ѳ */
#define LOG_TYPE_DSP			UINT_C(0x14)    /* ǥѥå */
#define LOG_TYPE_SVC			UINT_C(0x15)    /* ӥ */
#define LOG_TYPE_SCHTBL			UINT_C(0x16)    /* 塼ơ֥λ */
#define LOG_TYPE_STAHOOK		UINT_C(0x17)    /* ȥåץեå */
#define LOG_TYPE_ERRHOOK		UINT_C(0x18)    /* 顼եå */
#define LOG_TYPE_PROHOOK		UINT_C(0x19)    /* ץƥեå */
#define LOG_TYPE_SHUTHOOK		UINT_C(0x1a)    /* åȥեå */
#define LOG_TYPE_STAHOOKOSAP	UINT_C(0x1b)    /* OSAPȥåץեå */
#define LOG_TYPE_ERRHOOKOSAP	UINT_C(0x1c)    /* OSAP顼եå */
#define LOG_TYPE_SHUTHOOKOSAP	UINT_C(0x1d)    /* OSAPåȥեå */
#define LOG_TYPE_TFN			UINT_C(0x1e)    /* ؿ */
#define LOG_TYPE_INSHUTALLCORES	UINT_C(0x1f)    /* OSShutdownAllCoresθƤӽФ */
#define LOG_TYPE_WSUSALL		UINT_C(0x20)    /* ԥååԥ󥰤߶ػ */
#define LOG_TYPE_WRSMALL		UINT_C(0x21)    /* ԥååԥ󥰤߶ػ߲ */
#define LOG_TYPE_WSUSOSI		UINT_C(0x22)    /* ԥååԥ󥰤OS߶ػ */
#define LOG_TYPE_WRSMOSI		UINT_C(0x23)    /* ԥååԥ󥰤OS߶ػ߲ */

#define LOG_ENTER			UINT_C(0x00)    /*  */
#define LOG_LEAVE			UINT_C(0x80)    /* иλ */

/*
 *  ν٤
 */
#define LOG_EMERG			UINT_C(0)       /* åȥͤ륨顼 */
#define LOG_ALERT			UINT_C(1)
#define LOG_CRIT			UINT_C(2)
#define LOG_ERROR			UINT_C(3)       /* ƥ२顼 */
#define LOG_WARNING			UINT_C(4)       /* ٹå */
#define LOG_NOTICE			UINT_C(5)
#define LOG_INFO			UINT_C(6)
#define LOG_DEBUG			UINT_C(7)       /* ǥХåѥå */

#ifndef TOPPERS_MACRO_ONLY

/*
 *  ѥǡ
 */

typedef uint32 ObjectIDType;                /* ֥ȤIDֹ */

/*
 *  Υǡ¤
 */

#define TMAX_LOGINFO	UINT_C(6)

typedef struct {
	uint32				logtype;                /* μ */
	SystemTimeMsType	logtim;                 /*  */
	uintptr				loginfo[TMAX_LOGINFO];  /* ¾Υ */
} SYSLOG;

/*
 *  ν٤Υӥåȥޥåפ뤿Υޥ
 */
#define LOG_MASK(prio)		(1U << (prio))
#define LOG_UPTO(prio)		((((uint32) 1) << ((prio) + 1U)) - 1U)

#ifndef TOPPERS_OMIT_SYSLOG

/*
 *  Ϥ뤿Υ饤֥ؿ(syslog.c)
 */
extern StatusType syslog_wri_log(uint32 prio, const SYSLOG *p_syslog);

LOCAL_INLINE void
_syslog_1(uint32 prio, uint32 type, uintptr arg1)
{
	SYSLOG syslog;

	syslog.logtype = type;
	syslog.loginfo[0] = arg1;
	(void) syslog_wri_log(prio, &syslog);
}

LOCAL_INLINE void
_syslog_2(uint32 prio, uint32 type, uintptr arg1, uintptr arg2)
{
	SYSLOG syslog;

	syslog.logtype = type;
	syslog.loginfo[0] = arg1;
	syslog.loginfo[1] = arg2;
	(void) syslog_wri_log(prio, &syslog);
}

LOCAL_INLINE void
_syslog_3(uint32 prio, uint32 type, uintptr arg1, uintptr arg2,
		  uintptr arg3)
{
	SYSLOG syslog;

	syslog.logtype = type;
	syslog.loginfo[0] = arg1;
	syslog.loginfo[1] = arg2;
	syslog.loginfo[2] = arg3;
	(void) syslog_wri_log(prio, &syslog);
}

LOCAL_INLINE void
_syslog_4(uint32 prio, uint32 type, uintptr arg1, uintptr arg2,
		  uintptr arg3, uintptr arg4)
{
	SYSLOG syslog;

	syslog.logtype = type;
	syslog.loginfo[0] = arg1;
	syslog.loginfo[1] = arg2;
	syslog.loginfo[2] = arg3;
	syslog.loginfo[3] = arg4;
	(void) syslog_wri_log(prio, &syslog);
}

LOCAL_INLINE void
_syslog_5(uint32 prio, uint32 type, uintptr arg1, uintptr arg2,
		  uintptr arg3, uintptr arg4, uintptr arg5)
{
	SYSLOG syslog;

	syslog.logtype = type;
	syslog.loginfo[0] = arg1;
	syslog.loginfo[1] = arg2;
	syslog.loginfo[2] = arg3;
	syslog.loginfo[3] = arg4;
	syslog.loginfo[4] = arg5;
	(void) syslog_wri_log(prio, &syslog);
}

LOCAL_INLINE void
_syslog_6(uint32 prio, uint32 type, uintptr arg1, uintptr arg2,
		  uintptr arg3, uintptr arg4, uintptr arg5, uintptr arg6)
{
	SYSLOG syslog;

	syslog.logtype = type;
	syslog.loginfo[0] = arg1;
	syslog.loginfo[1] = arg2;
	syslog.loginfo[2] = arg3;
	syslog.loginfo[3] = arg4;
	syslog.loginfo[4] = arg5;
	syslog.loginfo[5] = arg6;
	(void) syslog_wri_log(prio, &syslog);
}

/*
 *  ʥȡˤϤ뤿Υ饤֥ؿvasyslog.c
 */
extern void syslog(uint32 prio, const char8 *format, ...);

#else /* TOPPERS_OMIT_SYSLOG */

/*
 *  ƥϤ޻ߤ
 */

LOCAL_INLINE void
_syslog_1(uint32 prio, uint32 type, uintptr arg1)
{
}

LOCAL_INLINE void
_syslog_2(uint32 prio, uint32 type, uintptr arg1, uintptr arg2)
{
}

LOCAL_INLINE void
_syslog_3(uint32 prio, uint32 type, uintptr arg1, uintptr arg2,
		  uintptr arg3)
{
}

LOCAL_INLINE void
_syslog_4(uint32 prio, uint32 type, uintptr arg1, uintptr arg2,
		  uintptr arg3, uintptr arg4)
{
}

LOCAL_INLINE void
_syslog_5(uint32 prio, uint32 type, uintptr arg1, uintptr arg2,
		  uintptr arg3, uintptr arg4, uintptr arg5)
{
}

LOCAL_INLINE void
_syslog_6(uint32 prio, uint32 type, uintptr arg1, uintptr arg2,
		  uintptr arg3, uintptr arg4, uintptr arg5, uintptr arg6)
{
}

LOCAL_INLINE void
syslog(uint32 prio, const char8 *format, ...)
{
}

#endif /* TOPPERS_OMIT_SYSLOG */

/*
 *  ʥȡˤϤ뤿Υޥ
 *
 *  formatӸ³ΰå򡤽prioǥ
 *  ȤƽϤ뤿Υޥ
 *  arg1argnuintptr˥㥹Ȥ뤿ᡤuintptr˷ѴǤǤ
 *  դηǤ褤
 */

#define syslog_0(prio, format) \
	_syslog_1((prio), LOG_TYPE_COMMENT, (uintptr) (format))

#define syslog_1(prio, format, arg1)						\
	_syslog_2((prio), LOG_TYPE_COMMENT, (uintptr) (format),	\
			  (uintptr) (arg1))

#define syslog_2(prio, format, arg1, arg2)					\
	_syslog_3((prio), LOG_TYPE_COMMENT, (uintptr) (format),	\
			  (uintptr) (arg1), (uintptr) (arg2))

#define syslog_3(prio, format, arg1, arg2, arg3)			\
	_syslog_4((prio), LOG_TYPE_COMMENT, (uintptr) (format),	\
			  (uintptr) (arg1), (uintptr) (arg2), (uintptr) (arg3))

#define syslog_4(prio, format, arg1, arg2, arg3, arg4)				\
	_syslog_5((prio), LOG_TYPE_COMMENT, (uintptr) (format),			\
			  (uintptr) (arg1), (uintptr) (arg2), (uintptr) (arg3),	\
			  (uintptr) (arg4))

#define syslog_5(prio, format, arg1, arg2, arg3, arg4, arg5)		\
	_syslog_6((prio), LOG_TYPE_COMMENT, (uintptr) (format),			\
			  (uintptr) (arg1), (uintptr) (arg2), (uintptr) (arg3),	\
			  (uintptr) (arg4), (uintptr) (arg5))

#endif /* TOPPERS_MACRO_ONLY */

#endif /* TOPPERS_T_SYSLOG_H */
