/*
 *  TOPPERS ATK2
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Kernel Version 2
 *
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2004-2013 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2011-2013 by FUJISOFT INCORPORATED, JAPAN
 *  Copyright (C) 2011-2013 by FUJITSU VLSI LIMITED, JAPAN
 *  Copyright (C) 2011-2013 by NEC Communication Systems, Ltd., JAPAN
 *  Copyright (C) 2011-2013 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
 *  Copyright (C) 2011-2013 by Renesas Electronics Corporation, JAPAN
 *  Copyright (C) 2011-2013 by Sunny Giken Inc., JAPAN
 *  Copyright (C) 2011-2013 by TOSHIBA CORPORATION, JAPAN
 *  Copyright (C) 2004-2013 by Witz Corporation, JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: counter.h 7615 2013-06-25 09:31:59Z fsi-dankei $
 */

/*
 *		󥿵ǽ
 */

#ifndef TOPPERS_COUNTER_H
#define TOPPERS_COUNTER_H

#include "queue.h"

/*
 *  󥿾֤
 *  IncrementCounterΥͥɻߺ
 */
#define CS_NULL		(FALSE)         /*  */
#define CS_DOING	(TRUE)          /*  */

/*
 *  ID饫󥿴֥åФΥޥ
 */
#define get_cntcb(cntid)	(p_cntcb_table[(cntid)])

/*
 *  IDǥϡɥ󥿤åѥޥ
 */
#define is_hwcnt(cntid)		((cntid) < tnum_hardcounter)

/*
 *  CNTCB饫IDФΥޥ
 */
#define CNTID(p_cntcb)	((CounterType) (((p_cntcb)->p_cntinib) - cntinib_table))

/*
 *  λ°
 */
#define ACTIVATETASK		UINT_C(0x01)    /* ư */
#define SETEVENT			UINT_C(0x02)    /* ٥ȥå */
#define CALLBACK			UINT_C(0x04)    /* Хå */
#define INCREMENTCOUNTER	UINT_C(0x08)    /* 󥿥󥯥 */

/*
 *  ưư°
 */
#define ABSOLUTE			UINT_C(0x10)    /* ͵ư */
#define RELATIVE			UINT_C(0x20)    /* ͵ư */

/*
 *  ƥϡɥ󥿽ؿ
 */
typedef void (*HardwareCounterInitRefType)(TickType maxval, TimeType nspertick);    /* ؿ */
typedef void (*HardwareCounterStartRefType)(void);                                  /* ϴؿ */
typedef void (*HardwareCounterStopRefType)(void);                                   /* ߴؿ */
typedef void (*HardwareCounterSetRefType)(TickType exprtick);                       /* ؿ */
typedef TickType (*HardwareCounterGetRefType)(void);                                /* ּؿ */
typedef void (*HardwareCounterCancelRefType)(void);                                 /* ּôؿ */
typedef void (*HardwareCounterTriggerRefType)(void);                                /* ׵ؿ */
typedef void (*HardwareCounterIntClearRefType)(void);                               /* ׵᥯ꥢؿ */
typedef void (*HardwareCounterIntCancelRefType)(void);                              /* ׵ôؿ */
typedef void (*HardwareCounterIncrementRefType)(void);                              /* 󥯥ȴؿ */

/*
 *  ϡɥ󥿽ؿ
 */
typedef struct hardware_counter_initialization_block {
	HardwareCounterInitRefType		init;               /* ؿݥ */
	HardwareCounterStartRefType		start;              /* ϴؿݥ */
	HardwareCounterStopRefType		stop;               /* ߴؿݥ */
	HardwareCounterSetRefType		set;                /* ؿݥ */
	HardwareCounterGetRefType		get;                /* ּؿݥ*/
	HardwareCounterCancelRefType	cancel;             /* ּôؿݥ */
	HardwareCounterTriggerRefType	trigger;            /* ׵ؿݥ */
	HardwareCounterIntClearRefType	intclear;           /* ׵᥯ꥢؿ */
	HardwareCounterIntCancelRefType	intcancel;          /* ׵ôؿ */
	HardwareCounterIncrementRefType	increment;          /* 󥯥ȴؿݥ */
	TimeType						nspertick;          /* ϡɥ󥿤Ǥ1ƥåνŤ(nsñ) */
	CoreIdType						coreid;             /* դ */
} HWCNTINIB;

/*
 *  󥿽֥å
 */
typedef struct counter_initialization_block {
	TickType	maxval;                                 /* 󥿤κ */
	TickType	maxval2;                                /* 󥿤κͤ2+1 */
	TickType	tickbase;                               /* OSǤϻѤ桼ͳ˻Ѥ */
	TickType	mincyc;                                 /* κǾ */
	CoreIdType	coreid;                                 /* դ */
#if TTYPE_KLOCK == C_KLOCK
	LockType *p_cnt_lock;                                   /* 󥿥åؤΥݥ */
#endif /* TTYPE_KLOCK == C_KLOCK */

	const OSAPINIB *p_osapinib;                         /* °OSץꥱ֥å */
} CNTINIB;

/*
 *  󥿴֥å
 */
typedef struct counter_control_block {
	QUEUE			cntexpque;                          /* λ塼 */
	const CNTINIB	*p_cntinib;                         /* 󥿽֥åݥ */
	TickType		curval;                             /* 󥿤θߥƥå */
	boolean			cstat;                              /* ե饰 */
} CNTCB;

/*
 *  λ
 */
typedef struct counter_expire_info CNTEXPINFO;

/*
 *  λؿ
 */
typedef void (*EXPFP)(CNTEXPINFO *p_cntexpinfo, const CNTCB *p_cntcb);

/*
 *  λ
 */
struct counter_expire_info {
	QUEUE		cntexpque;                              /* λ塼(¤ΤƬɬ) */
	TickType	expiretick;                             /* λ륫󥿾Υƥå */
	EXPFP		expirefunc;                             /* λؿݥ */
};


/*
 *  ϡɥ󥿿ݻѿOs_Lcfg.c
 */
extern const CounterType	tnum_hardcounter;

/*
 *  󥿿ݻѿOs_Lcfg.c
 */
extern const CounterType	tnum_counter;

/*
 *  󥿽֥åΥꥢOs_Lcfg.c
 */
extern const CNTINIB		cntinib_table[];

/*
 *  󥿴֥åΥꥢOs_Lcfg.c
 */
extern CNTCB * const		p_cntcb_table[];

/*
 *  ϡɥ󥿽ؿơ֥Os_Lcfg.c
 */
extern const HWCNTINIB		hwcntinib_table[];

/*
 *  ƥåͤβû
 */
LOCAL_INLINE TickType
add_tick(TickType val, TickType incr, TickType maxval2)
{
	TickType result;
	/*
	 *  ľʾＰ val + incr <= maxval2 Ǥ뤬ξＰ
	 *  ϡval + incr  TickType ɽϰϤĶ
	 *  ȽǤʤʤ뤿ᡤξＰȤƤ
	 */
	if (incr <= (maxval2 - val)) {
		result = val + incr;
	}
	else {
		/*
		 *  η׻ǡval + incr  maxval2 + 1  TickType ɽ
		 *  ϰϤĶ礬뤬ХեƤޤͤ
		 *  ẹ٤ʤ
		 */
		result = (val + incr) - (maxval2 + 1U);
	}
	return(result);
}

/*
 *  ƥåͤκ
 */
LOCAL_INLINE TickType
diff_tick(TickType val1, TickType val2, TickType maxval2)
{
	TickType result;

	if (val1 >= val2) {
		result = val1 - val2;
	}
	else {
		/*
		 *  η׻ǡval1 - val2  maxval2 + 1  TickType ɽ
		 *  ϰϤĶ礬뤬ХեƤޤͤ
		 *  ẹ٤ʤ
		 */
		result = (val1 - val2) + (maxval2 + 1U);
	}
	return(result);
}

/*
 *  󥿤θͼ
 *  եȥ󥿤ξ, CNTCBcurvalǡ֤
 *  ϡɥ󥿤ξ, ǿθ߻֤֤
 */
LOCAL_INLINE TickType
get_curval(const CNTCB *p_cntcb, CounterType cntid)
{
	TickType curval;

	/* ͤμ */
	if (is_hwcnt(cntid)) {
		curval = (hwcntinib_table[cntid].get)();
	}
	else {
		curval = p_cntcb->curval;
	}

	return(curval);
}

/*
 *  ꤷл֤Υͼ(APIμ)
 */
extern TickType get_reltick_api(const CNTCB *p_cntcb, TickType relval);

/*
 *  ꤷл֤Υͼ(APIμ)
 */
extern TickType get_abstick_api(const CNTCB *p_cntcb, TickType absval);

/*
 *  󥿵ǽν
 */
extern void counter_initialize(void);

/*
 *  󥿵ǽνλ
 */
extern void counter_terminate(void);

/*
 *  λ塼ؤ
 */
extern void insert_cnt_expr_que(CNTEXPINFO *p_cntexpinfo, const CNTCB *p_cntcb);

/*
 *  λ塼
 */
extern void delete_cnt_expr_que(CNTEXPINFO *p_cntexpinfo, const CNTCB *p_cntcb);

/*
 *  󥿤λ
 */
extern void expire_process(CNTCB *p_cntcb, CounterType cntid);

/*
 *  ϡɥλ
 */
extern void notify_hardware_counter(CounterType cntid);

/*
 *  󥿤Υ󥯥
 *
 *  ߶ػ߾֤ǸƤФ
 */
extern StatusType incr_counter_action(CounterType CounterID);

#endif /* TOPPERS_COUNTER_H */
